
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《SQL Server企业级平台管理实践》读书笔记——几个系统库的备份与恢复 / iVAN</title>

    <meta name="description" content="《SQL Server企业级平台管理实践》读书笔记——几个系统库的备份与恢复 原文:&lt;SQL Server企业级平台管理实践&gt;读书笔记--几个系统库的备份与恢复 master数据库 master作为数据库的主要数据库,记录着SQL Server系统的所有系统级信息,例如登录用户.系统配置设置.端点和凭证以及访问其他数据服务器所需要的信息.master数据库还记录着启动服务器实例所需要的初始化信息,每个其它数据库的主文件位置.master数据库是SQL Server启动的时候打开的第一个数据库.SQL Server是从这个数据库里找到其它数据的信息的.如果mas ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">《SQL Server企业级平台管理实践》读书笔记——几个系统库的备份与恢复</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>原文:<a href="http://www.cnblogs.com/zhijianliutang/p/4081656.html" rel="external nofollow noreferrer">《SQL Server企业级平台管理实践》读书笔记——几个系统库的备份与恢复</a><br />
<br /><strong>master数据库</strong></p>
<p>master作为数据库的主要数据库，记录着SQL Server系统的所有系统级信息，例如登录用户、系统配置设置、端点和凭证以及访问其他数据服务器所需要的信息。master数据库还记录着启动服务器实例所需要的初始化信息，每个其它数据库的主文件位置。master数据库是SQL Server启动的时候打开的第一个数据库。SQL Server是从这个数据库里找到其它数据的信息的。如果master数据库有问题，整个SQL Server都将无法启动。</p>
<p>master数据库本身不大，做一次备份很快。建议要经常做master的完整数据库备份，以充分保护您的数据。如果master数据库已损坏，可以通过还原master数据库的最近完整数据库备份，轻松修复已损坏的数据库。</p>
<p>如果由于master数据库损坏严重大无法启动服务器实例，有没有备份，这时候只能重建了。重建master数据将使的所有的系统数据库恢复到其原始状态。例如，重建master数据库会删除并重新创建msdb数据库。这将导致丢失所有的计划信息以及备份和还原历史记录。所以重建master数据库后，SQL Server就像被重装过一样。所有的用户记录都会丢失，用户数据库需要再次附加，SQL Server任务记录都要重建。这是一个很折腾的过程。重建master数据库是个万不得已的选择。</p>
<p>在执行任何语句或系统过程中来更改master数据库中的信息以后（例如，更改服务器范围的配置选项以后），应备份master数据库。如果在更改master数据库后没有进行备份，则自上次备份以来的更改都将在还原备份时丢失。</p>
<p>一下行为会更改master中元数据：</p>
<p>1、创建或删除用户数据库，这里不包括用户数据库自动增长以容纳新数据时，master数据时不受影响的。</p>
<p>2、添加或删除文件和文件组</p>
<p>3、添加登录或其它与登录安全相关的操作，这里不包括对数据库层面的操作，比如添加用户</p>
<p>4、更改服务器范围的配置选项或数据库配置选项</p>
<p>5、创建或删除逻辑备份设备</p>
<p>6、配置用于分布式查询和远程过程调用（RPC）的服务器，如添加链接服务器或远程登录。</p>
<p>恢复master数据库使用还是RESTORE指令。可是还原master数据库后，SQL Server实例将自动停止。我们前面讲过，master里面记录了其他所有数据库主文件的地址。SQL Server通过这个地址来寻找这些数据库。如果我们将master数据库恢复到一台新的服务器上，难免文件地址会有所变化。这时SQL Sever将找不到其它数据库。需要使用单用户模式启动SQL Server，将master数据库里信息修改成新的地址。</p>
<p>开启单用户模式，需要停止所有SQL Server服务（服务器实例本身除外），并停止所有SQL Server实用工具（SQL Server代理，报表服务器等）。停止服务和实用工具可以防止他们尝试访问服务器实例。否则单用户启动后，他们会占用这个用户连接，管理员反而连接不进去了。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19iZTQ4NWExMjc1Mzg2ODdjNmE3ZGI0NTk4NTIxNjhjYS5wbmc=.jpg"></p>
<p><strong>model 数据库</strong></p>
<p>创建用户数据库时，model数据库是SQL Server使用的模板。model数据库的全部内容（包括数据库选项）都会被复制到新的数据库。所以这个数据库是推荐做任何修改的。除非有目的的创建一些模板，否则不要去更改这个数据库，也不要把任何用户数据放在这个数据库里。</p>
<p>虽然这个数据库的内容一般不发生变化，但是在SQL Server启动的时候，要使用model数据库的某些设置创建新的tempdb。如果没有tempdb，SQL Server将无法启动。因此model数据库必须始终存在于SQL Server系统中。所以这个数据库也要备份。</p>
<p>还原model数据库与对用户数据执行完整数据库还原过程一样。</p>
<p><strong>msdb数据库</strong></p>
<p>msdb数据库用来存储计划信息以及备份与还原历史记录的信息，所以SQL Server本身，ssms和Agentd都要用到它。</p>
<p>SQL Server将在msdb数据库中自动维护一份完整在下备份与还原历史记录。这些信息包括执行备份一方的名称、备份时间和用来存储备份的设备或文件。SSMS利用这些信息提出计划还原数据库并应用事务日志备份。将会记录有关所有数据库备份事件，即使他们由自定义程序或第三方创建的。例如，如果使用C#程序调用SQL Server执行备份操作时，所有的事件都将记录在msdb系统表、windows应用程序日志和SQL Server错误日志中。而SQL Server代理使用的所有计划信息。包括计划的定义、排程、历史日志等信息。</p>
<p>默认情况下，msdb数据库使用简单恢复模式。如果要恢复用户数据库时使用msdb数据库中的所有备份与还原历史记录信息，建议对msdb数据库使用完整恢复模式，并建议考虑将msdb数据库事务日志放置在容错存储设备中。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ183ZGIxZjJkNDQzMGRjOWY2NTc4MzlhZmM0OTg4OTViNy5wbmc=.jpg"></p>
<p><strong>tempdb临时库和资源数据库（Resource Databse）</strong></p>
<p>SQL Server还有两个系统数据库比较特别。他们是tempdb和资源数据库。缺了这个两个数据库SQL  Server页将无法启动。但是这两个库不能做数据库备份。</p>
<p>temdp系统数据库是一个全局资源。可供连接到SQL Server实例的所有用户使用。</p>
<p>每次启动SQL Server时都会重建tempdb数据库，从而在系统启动时总保持一个干净的数据库副本。连接断了以后，SQL Server会自动删除临时表和存储过程。因此tempdb数据库中不会有什么内容需要在服务关闭的时候保存下来。只要有干净的model数据库就可以。SQL Server都能够创建出一个tempdb数据库。Temdp数据本身倒不用备份。SQL Server同样也没有提供对tempdb数据库的备份和还原操作。保护好model数据库，就能保证在下次启动时，得到一个好的tempdb数据库。所以对tempdb数据库保护，转为了对model数据库的保护。</p>
<p>Resource数据时一个只读数据库。它包含了SQL Server中所有的系统对象。系统对象（例如sys.objects）在物理上存在于Resource数据库中。但是在逻辑上，他们出现在每个数据库的sys结构中。Resource数据库不包含任何用户或用户元数据。对于同一个版本的SQL Server。他们的Resource数据库应该都是一样的。</p>
<p>默认在实例下是看不到资源库的，但是Resource数据库的物理存在的，物理文件名为mssqlsystemresource.mdf和mssqlsystemresource.ldf。默认情况下，这些文件存储于目录:\Program Files\Microsoft SQL Server\MSSQL10.SQLEXPRESS\MSSQL</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18zODQ5YWE0ZjcyYTgwNWFiNzE4ZWFkYjNjZDk5ZDJjYS5wbmc=.jpg"></p>
<p>在群集中，Resource数据库位于共享磁盘中的Data文件夹中。其实Resource数据库依赖于master数据库位置。如果管理员移动了master数据库，则必须也将Resource数据库移动到相同的位置。</p>
<p>因为Resource数据库从来不做修改，所以SQL Server理论上不用备份的。但是管理员不但要考虑SQL Server层面的问题。还要考虑整个系统层面的问题。难免物理磁盘损坏会发生，使得文件出现损坏。所以要通过将mssqlsystemresource.mdf文件作为二进制文件，做基于文件的备份或基于磁盘的备份。恢复时要将SQL 服务停止。手段还原mssqlsystemresource.mdf的文件备份副本。并且必须谨慎，不同版本的Resource数据库会不一样。是要使用过期版本或可能不安全的版本覆盖当前Resource数据库。</p>
<p> 我们集中列举下</p>
<table>
<tbody>
<tr>
<td>系统数据库</td>
<td>说明　　</td>
<td>是否支持备份</td>
<td>恢复模式</td>
<td>注释</td>
</tr>
<tr>
<td>master</td>
<td>记录SQL Server系统的所有系统级别信息的数据库</td>
<td>支持</td>
<td>简单</td>
<td>
<br />必须经常备份Master数据库，以便根据业务需要充分</p>
<p>保护数据。建议使用定期备份计划，这样在大量更新</p>
<p>之后可以补充更多的备份</p>
</td>
</tr>
<tr>
<td>model</td>
<td>在SQL Server实例上为所有数据库创建的模板</td>
<td>支持</td>
<td>用户可配置</td>
<td>
<br />仅在业务需要时备份model数据库，例如自定义其数据</p>
<p>库选项后立即备份。最佳方法是：建议根据需要创建</p>
<p>model数据库完整性数据库备份。由于model数据库较小</p>
<p>而且很少更改，因此无需备份日志</p>
</td>
</tr>
<tr>
<td>msdb　　</td>
<td>
<br />SQL Server代理用来安排报警和作业以及记录操作员</p>
<p>信息的数据库。msdb数据库还包含历史记录表，例如</p>
<p>备份和还原历史记录表</p>
</td>
<td>支持</td>
<td>简单（默认值）</td>
<td>更新时备份msdb数据库</td>
</tr>
<tr>
<td>Resource(RDB)</td>
<td>
<br />包含SQL Server附带的所有系统对象副本的只读</p>
<p>数据库</p>
</td>
<td>不支持</td>
<td> </td>
<td>
<br />Resource数据库位于mssqlsystemresource.mdf文件中，</p>
<p>该文件近包含代码。因此，SQL Server不能备份Resource数据库。</p>
<p>但是可以通过文件备份和磁盘备份，同样还原的时候不通过SQL Server，</p>
<p>还原这些备份，只能手动还原mssqlsystemresource.mdf的备份副本，</p>
<p>并且必须谨慎，不要使用过期版本或可能不安全的版本覆盖当前的Resource数据库</p>
</td>
</tr>
<tr>
<td>tempdb</td>
<td>
<br /> 用于保存历史或中间结果集的工作空间，</p>
<p>每次启动SQL Server实例时都会重建该库，服务</p>
<p>器实例关闭时，将永久删除Tempdb数据库中的所有数据</p>
</td>
<td>不支持</td>
<td>简单</td>
<td>
<br /> 无法备份tempdb系统数据库</p>
</td>
</tr>
<tr>
<td>distribution</td>
<td>
<br /> 只有将服务器配置为复制分发服务器时才存在</p>
<p>此数据库。此数据库存储元数据库、各种复制的历史记录数据以及用于事务复制的事务</p>
</td>
<td>支持</td>
<td>简单</td>
<td>
<br /> 根据您具体的复制配置决定</p>
</td>
</tr>
</tbody>
</table>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-12 14:21:17</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e7%a3%81%e7%9b%98/" title="磁盘">磁盘</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.iamivan.net/tag/sql/" title="sql">sql</a>, <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1%e5%99%a8/" title="服务器">服务器</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>, <a href="https://www.iamivan.net/tag/server/" title="server">server</a>, <a href="https://www.iamivan.net/tag/%e6%97%a5%e5%bf%97/" title="日志">日志</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>《SQL Server企业级平台管理实践》读书笔记——几个系统库的备份与恢复的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b32BWwz.html" rel="bookmark">《SQL Server企业级平台管理实践》读书笔记&mdash;&mdash;关于SQL Server数据库的备份方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:&lt;SQL Server企业级平台管理实践&gt;读书笔记--关于SQL Server数据库的备份方式 数据备份一直被认为数据库的生命,也就是一个DBA所要掌握的主要技能之一,本篇就是介绍SQL Server备份原则,SQL Server数据库分为数据文件和日志文件.为了使得数据库能够恢复一致点,备份不仅需要拷贝数据数据文件里的内容,还要拷贝日志文件里的内容.那么根据每次备份的目标不同,我们可以将备份分为数据备份和日志备份. 数据备份的范围可以是完整的数据库.部分数据库.一组文件或文件组.所以根			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZEPBBp.html" rel="bookmark">《SQL Server企业级平台管理实践》读书笔记&mdash;&mdash;SQL Server中数据文件空间使用与管理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:&lt;SQL Server企业级平台管理实践&gt;读书笔记--SQL Server中数据文件空间使用与管理 1.表和索引存储结构 在SQL Server2005以前,一个表格是以一个B树或者一个堆(heap)存放的.每个B树或者堆,在sysindexes里面都有一条记录相对应.SQL Server2005以后,引入了分区表的概念(Table Partition),在存储组织上,现有的分区基本上替代了原来表格的概念,原先表的概念成为了一个逻辑概念.一个分区就是一个B树或者一个堆.而一张表格则是一个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bB1PWaz.html" rel="bookmark">《SQL Server企业级平台管理实践》读书笔记&mdash;&mdash;SQL Server数据库文件分配方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:&lt;SQL Server企业级平台管理实践&gt;读书笔记--SQL Server数据库文件分配方式 1.文件分配方式以及文件空间检查方法 最常用的检查数据文件和表大小的命令就是:sp_spaceused 此命令有三个缺陷:1.无法直观的看出每个数据文件和日志文件的使用情况.2.这个存储过程依赖SQL Server存储在一些系统视图里的空间使用统计信息计算出的结果,如果没有更新空间统计信息,比如刚刚发生大数据插入,sp_spaceused的结果就不准确.3.这个命令主要是针对普通用户的数据库,对			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwWBG5z.html" rel="bookmark">《SQL Server企业级平台管理实践》读书笔记&mdash;&mdash;当我们的备份都已经损坏的时候该怎么办</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:&lt;SQL Server企业级平台管理实践&gt;读书笔记--当我们的备份都已经损坏的时候该怎么办 作为数据库管理员最最痛苦的莫过于,当数据库宕机的时候需要找备份,但在这个时候突然发现备份文件也是坏的,这就意味着数据会丢失,为此可能会丢掉职位,饭碗不保,所以为此,我们一定要保证好备份的完整性,一般发生这种情况的原因莫过于一下几种: 1.备份文件和数据库放在同一个(或一组)的物理磁盘上.磁盘出现故障,备份也保不住了. 2.备份介质随坏,或者做的是网络备份,数据在网络传输中发生了损坏. 3.数据库在			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8YlYPz.html" rel="bookmark">《SQL Server企业级平台管理实践》读书笔记&mdash;&mdash;SQL Server中收缩数据库不好用的原因</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:&lt;SQL Server企业级平台管理实践&gt;读书笔记--SQL Server中收缩数据库不好用的原因 数据库管理员有时候需要控制文件的大小,可能选择收缩文件,或者把某些数据文件情况以便从数据库里删除. 这时候我们就要使用到DBCC SHRINKFILE命令,此命令的脚本为: DBCC SHRINKFILE ( { file_name | file_id } { [ , EMPTYFILE ] | [ [ , target_size ] [ , { NOTRUNCATE | TRUNCATE			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6Yo4Ab.html" rel="bookmark">《SQL Server企业级平台管理实践》读书笔记&mdash;&mdash;SQL Server如何设置自动增长和自动收缩项</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:&lt;SQL Server企业级平台管理实践&gt;读书笔记--SQL Server如何设置自动增长和自动收缩项 SQL Server允许用户设置数据库初始值和最大值,可以通过自动增长或者自动收缩进行配置.通过这些配置,我们可以防止数据库空间问题而导致的应用程序修改失败或者SQL Server磁盘空间耗尽的事情发生.一般来讲,如果数据库不是很忙,默认的设置为自动增长,这种方式能够满足大部分的需求.但是在大量并发的情况下,申请数据文件和日志文件增长本身是一件非常消耗系统资源和影响性能的工作.所以如果			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOlW0xb.html" rel="bookmark">&period;NET编程和SQL Server &mdash;&mdash;Sql Server 与CLR集成 （学习笔记整理-1）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:.NET编程和SQL Server --Sql Server 与CLR集成 (学习笔记整理-1) 一.SQL Server 为什么要与CLR集成 1. SQL Server 提供的存储过程.函数等十分有限,经常需要外部的代码来执行一些繁重的移植: 2.与CLR集成可将原本需要独立的程序来实现的功能迁移到SQL Server 内部进行数据操作: 3.T-SQL数据查询语言在返回数据集方面很好,但是除此之外表现不佳.与CLR的集成可解决这一问题: 4..NET的操作代码和执行的速度比T-SQL			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boR8Ydz.html" rel="bookmark">JavaScript 设计模式与开发实践读书笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JavaScript 设计模式与开发实践读书笔记 最近利用碎片时间在 Kindle 上面阅读&lt;JavaScript 设计模式与开发实践读书&gt;这本书,刚开始阅读前两章内容,和大家分享下我觉得可以在项目中用的上的一些笔记. 我的 github 项目会不定时更新,有需要的同学可以移步到我的 github 中去查看源码: https://github.com/lichenbuliren/design-mode-notes 1.currying 函数柯里化 currying 又称 部分求值 .一个 cu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zenoXVb.html" rel="bookmark">SQL Server中TempDB管理（版本存储区的一个example）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:SQL Server中TempDB管理(版本存储区的一个example) 原文来自: http://blogs.msdn.com/b/sqlserverstorageengine/archive/tags/tempdb/ http://blogs.msdn.com/b/sqlserverstorageengine/archive/2008/12/31/managing-tempdb-in-sql-server-tempdb-basics-version-store-simple-examp			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/dzZREwz.html" rel="bookmark" class="title">16个HTML5 框架、模板以及生成工具</a>
					<div>
						  网页设计通常需要预先考虑很多因素,而用户给你的时间又特别稀缺,如何提高效率其实是一个比较烦人的问题.一个可行方式就是使用预先准备好的框架和模板,HTML5框架.模板以及生成器是一个万灵丹似的解决方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Xpmvkwz.html" rel="bookmark" class="title">一个用VB编写的监控别人上网的软件例子</a>
					<div>
						一.程序核心 本程序的核心是通过API函数获得窗口句柄并获得浏览器访问的网址,在此基础上可以实现用Winsock控件进行远程的监视和管理. 1.先创建一个工程并在窗口Form1中,并声明下面的四个AP ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVnnoBz.html" rel="bookmark" class="title">通过一个Java应用服务器使用JRuby on Rails和XML增强Ajax</a>
					<div>
						Ruby on Rails 框架提供了一些非常方便的 XML 特性,这使使用数据库数据 进行开发和为 JavaScript 应用程序提供 XML 格式的数据库数据变得更加简单 .JavaScript  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/balm0wz.html" rel="bookmark" class="title">华为交换机的RRPP配置实验</a>
					<div>
						在工作中遇到了H3C和HW的RRPP配置,以下就以华为模拟器再作一次实验.大家共同来论讨论遇到的问题. [理论基础] RRPP具体的理论见配置手册 下面只点几个容易出错的地方 1.作为RRPP环的接口 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnx7kKb.html" rel="bookmark" class="title">如何解决无线路由不能上网故障</a>
					<div>
						一.无线路由不能上网的原因 在一次正常上网时,adsl moderm和无线路由器突然被断电,再次启动后笔记本就无法发现无线网络,无法上网,这是什么地方出现问题了呢?由于是在上网时网络设备意外断电导致故 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2y2arz.html" rel="bookmark" class="title">TurboGate邮件网关畅通国际海外邮</a>
					<div>
						近年来,我国对外贸易蓬勃发展,众多外贸企业的海外合作伙伴遍布全球各地.电子邮件因其便捷.廉价.无时差.实操性强的特性赢得了众多企业管理者的青睐,成为使用频率最高的通信工具之一.然而,企业邮件一旦出现收 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNEJKNb.html" rel="bookmark" class="title">delphi入门教程</a>
					<div>
						第一章-Delphi入门(一)(1) 第一章-Delphi入门(一)(2) 第一章-Delphi入门(一)(3) 第一章-Delphi入门(二)(1) 第一章-Delphi入门(二)(2) 第一章-D ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd72wxM.html" rel="bookmark" class="title">Flash CS4教程：制作切换扑克牌效果</a>
					<div>
						  本例思路: &lt;1&gt; 创建实例背景. &lt;2&gt; 绘制牌的正面和反面并转换为图形元件. &lt;3&gt; 创建一个牌的容器,转换为元件类&quot;Card&quot;,将正反 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1EeeKM.html" rel="bookmark" class="title">1到n的全排列</a>
					<div>
						#include &lt;iostream&gt; using namespace std; void PrintElements(int *elem, int size) { for (int i  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlB87Rz.html" rel="bookmark" class="title">微软官方提前确认Windows 7包装外观</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;   6月8日最新消息,微软已经提前出现在了微软官方商店里, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8RaZp.html" rel="bookmark" class="title">Java中List的使用方法简单介绍&lowbar;java</a>
					<div>
						Java中的List就是一种集合对象,将所有的对象集中到一起存储.List里面可以放任意的java对象,也可以直接放值. 使用方法很简单,类似于数组.  使用List之前必须在程序头引入java.ut ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32EnJz.html" rel="bookmark" class="title">Java 8十个lambda表达式案例</a>
					<div>
						1 实现Runnable线程案例 使用() -&gt; {} 替代匿名类: //Before Java 8: new Thread(new Runnable() { @Override public  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Pw7qp.html" rel="bookmark" class="title">lisp中的字符串和字符串操作</a>
					<div>
						字面量 引号 lisp使用双引号表示字符串字面量 CL-USER&gt; &quot;abc&quot; &quot;abc&quot; 转义 如果要包含双引号用'\'转义 CL-USER&gt; & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGAekOM.html" rel="bookmark" class="title">前后滑动-ios 一个列表，点击每一项进入一个页面，在进入到页面不停的滑动预览下一个，怎么实现？</a>
					<div>
						问题描述 ios 一个列表,点击每一项进入一个页面,在进入到页面不停的滑动预览下一个,怎么实现? ios 一个列表,点击每一项进入一个页面,在进入到页面不停的滑动预览下一个,怎么实现?可以往回滑动到前 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPq9Zp.html" rel="bookmark" class="title">下面TCPsocket通信问题的代码存在哪些问题</a>
					<div>
						问题描述 下面TCPsocket通信问题的代码存在哪些问题 package com.gp.Socket; import java.io.IOException; import java.net.Ser ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDXVGz.html" rel="bookmark" class="title">Lua中的weak表&mdash;&mdash;weak table（转）</a>
					<div>
						弱表(weak table)是一个很有意思的东西,像C++/Java等语言是没有的.弱表的定义是:A weak table is a table whose elements are weak ref ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY545rM.html" rel="bookmark" class="title">myeclipse-新人求助，关于tomcat</a>
					<div>
						问题描述 新人求助,关于tomcat 为什么我用myeclipse8.5用TOMCAT6.0会报404而用TMOCAT7.0就正常?代码没变. 解决方案 其实每个myeclipse都有一个与之相对应的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXY44z.html" rel="bookmark" class="title">JavaScript Window</a>
					<div>
						JavaScript Window - 浏览器对象模型 浏览器对象模型 (BOM) 使 JavaScript 有能力与浏览器&quot;对话&quot; 浏览器对象模型(Browser Object  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYa35p.html" rel="bookmark" class="title">党、政、军以及重要关键岗位的人员不得使用苹果手机</a>
					<div>
						据新华社电苹果公司继被曝收集用户详细行踪后,又再次被曝故意留&quot;后门&quot;提取iPhone用户的短信.通讯录和照片等个人数据. 对此,互联网实验室创始人方兴东建议,可要求党.政.军以及重 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7Z9RM.html" rel="bookmark" class="title">301与302重定向的区别有哪些</a>
					<div>
						 一,301永久重定向 被请求的资源已永久移动到新位置,并且将来任何对此资源的引用都应该使用本响应返回的若干个 URI 之一. 如果可能,拥有链接编辑功能的客户端应当自动把请求的地址修改为从服务器反馈 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZGa7z.html" rel="bookmark" class="title">link中可以按照属性来take么？而不是整个take出来？</a>
					<div>
						问题描述 link中可以按照属性来take么?而不是整个take出来? link中可以按照属性来take么?而不是整个take出来? 解决方案 那是select,不是take好不好					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyeeEZM.html" rel="bookmark" class="title">考虑好以下10个问题，你再转向SaaS</a>
					<div>
						云计算在是当下不少IT行业径向追捧的技术,当你想为自己的应用程序选择最适合的云平台时,你需要从长长的供应商名单中选择出最适合自己的那个,而评定因素也必不可少,需要从正常运行时间.安全性.工作性能.可扩 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEKj9Ap.html" rel="bookmark" class="title">android-安卓源码编译中 &num;include &amp;amp&semi;amp&semi;lt&semi;stdio&period;h&amp;amp&semi;amp&semi;gt&semi; 会报异常</a>
					<div>
						问题描述 安卓源码编译中 #include &lt;stdio.h&gt; 会报异常 在kernel/driver中的c文件里面调用FILE*类指针.添加#include 头文件就会报异常.请教如何解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK5OeOp.html" rel="bookmark" class="title">如何挖掘物联网的商业价值？</a>
					<div>
						物联网(IoT),智能硬件热火朝天, 真正解决了用户的痛点和行业痛点了吗?还是链接而链接智能而智能?就如下图:你会想要一个物联网的咖啡杯吗?不会吧! 物联网(IoT)话题正热,它是时下最流行的趋势.你 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOngPqp.html" rel="bookmark" class="title">js中如何复制一个对象并获取其所有属性和属性对应的值&lowbar;javascript技巧</a>
					<div>
						在js中如何复制一个对象,例如如下一个js对象. 如果知道这个对象的所有属性自然就可以重新new一个,然后对每个属性赋值,就可以做到,但如果不知道呢?如何创建一个内容相同 的对象呢? 复制代码 代码如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPlq7Ap.html" rel="bookmark" class="title">php版微信实现登录授权的实例</a>
					<div>
						用户授权也是高级接口那部分内容,只是把它独立出来,这样让整个微信框架条理清晰些,但我们用它首先要在微信后台设置OA2的URL,这里的URL和教程一的有所不同.它是不带http://开头的域名. 首先登 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYdkVb.html" rel="bookmark" class="title">关于依赖注入？不大理解？</a>
					<div>
						问题描述 个人理解:依赖注入最主要的目的就是解耦合,举个例子:比如A类中,需要使用到B类,而B类需要new,但若是在调用A类时,将已经new了的B类传递给A,这就是依赖注入.publicclassA{ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxEBmPp.html" rel="bookmark" class="title">c语言，参数传入错误，是个什么情况？</a>
					<div>
						问题描述 c语言,参数传入错误,是个什么情况? 我定义了一个函数,double abc(double a), 调用 double s=35.622 abc(s) 在函数abc中,s却变成了2.006  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOWd6qz.html" rel="bookmark" class="title">可牛软件收购了金山旗下的子公司贝壳安全</a>
					<div>
						TechWeb连线可牛CEO傅盛.贝壳安全陈睿,双方都没有进行否认,只表示&quot;稍后会有进一步消息公布&quot;.此前盛传知名天使投资人.金山软件前CEO雷军&quot;回归&quot;金山, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrvV21M.html" rel="bookmark" class="title">新手学习NET  求带&period;&period;&period;&period;</a>
					<div>
						问题描述 顶顶顶顶顶顶顶顶顶顶 解决方案 解决方案二:求大大.扣扣463627371解决方案三: 解决方案四:多看多练找人没用解决方案五: 解决方案六:多看书,多动脑,多实践,每个人都是这么过来的.解 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
